#include "Bullet.h"
#include "GL/OpenGL.h"
#include "GL/Material.h"
#include "Explosion.h"

Bullet::Bullet() : hit(false)
{
}

Bullet::~Bullet()
{
}


void Bullet::drawPO(const Frustum & f) const
{
	Material sphereMaterial(
	 Vector<GLfloat>(0.0, 0.0, 0.0, 0.0),
	 Vector<GLfloat>(0.5, 0.5, 0.5, 0.5),
	 Vector<GLfloat>(0.5, 0.5, 0.5, 0.5),
	 Vector<GLfloat>(0, 0, 0, 0),
	 0);

	 sphereMaterial.set();
	 OpenGL::SolidSphere(0.1, 20, 20);
}

void Bullet::onHitGround(double distance)
{
	x -= Vector<GLfloat>(0,distance,0,0,0,0);  // we're below ground, so subtract

	// lay still
	a = v = Vector<GLfloat>(6);

	hit = true;
}

bool	Bullet::recollect(vector<WorldObject*> & v)
{
	if (hit)
	{
		v.push_back(new Explosion(Vector<GLfloat>(3U, x)));
	}
	return !hit;
}
