#ifndef EXPLOSION_H
#define EXPLOSION_H

#include "GL/OpenGL.h"




/**
  *@author Wouter Koolen-Wijkstra
  */

#include "WorldObject.h"

class Tank;
class Lamp;

/** Uses dynamic light management (only takes a lamp if one is available)
*/

class Explosion : public WorldObject
{
public: 
			Explosion(const Vector<GLfloat> & x, double max_radius = 2.0, double speed = 10.0);
	virtual ~Explosion();

	const Vector<GLfloat> & getX() 		const;
	double 					getRadius() const;

protected:
	virtual void interactWithObject		(WorldObject 	& other);
	virtual void interactWithGrid		(Grid 			& other);
	virtual void interactWithTank		(Tank 			& other);

	virtual void	advance(double time, double dt);
	virtual bool	recollect(vector<WorldObject*> & v);

	virtual void	setLights(bool lit) const;
	virtual void	drawTransparent(const Frustum & f) 	const;

private:
	Vector<GLfloat> x;
	double 			radius;
	Lamp	*		flash;
	double 			max_radius;
	double			speed;
};

#endif
