#ifndef FIRECONE_H
#define FIRECONE_H

#include "GL/OpenGL.h"

/**
  *@author Wouter Koolen-Wijkstra
  */

#include "WorldObject.h"

/** Uses dynamic light management (only takes a lamp if one is available)
*/

class Lamp;


class FireCone : public WorldObject
{
public: 
			FireCone(const Vector<GLfloat> & x, const Vector<GLfloat> & d, double max_radius = 2.0, double speed = 10.0);
	virtual ~FireCone();

	const Vector<GLfloat> & getX() 		const;
	double 					getRadius() const;

protected:
	virtual void interactWithObject		(WorldObject 	& other);

	virtual void	advance(double time, double dt);
	virtual bool	recollect(vector<WorldObject*> & v);

	virtual void	setLights(bool lit) const;
	virtual void	drawTransparent(const Frustum & f) 	const;

private:
	Vector<GLfloat> 		x, d;
	double 					radius;
	Lamp	*				flash;
	double 					max_radius;
	double					speed;
};

#endif // FIRECONE
