#include "GL/OpenGL.h"
#include <cstdio>
#include "Framework.h"
#include "utils.h"
#include "Scene.h"
#include "Point.h"

#include <cstdlib>
#include <iostream>
using namespace std;


int 	Framework::x = 			800;
int 	Framework::y = 			600;
double 	Framework::startTime = 	getTime();
Scene * Framework::scene = 		NULL;


void Framework::fakeRenderFunc()
{
	printf("Redraw request ingored. Please wait for next frame\n");
	
}
 
void Framework::renderScene() 
{
	OpenGL::Clear(GL_COLOR_BUFFER_BIT);

	scene->draw(x, y);

	OpenGL::SwapBuffers();
}



void 	Framework::processNormalKeyDown	(unsigned char key, int x, int y)
{
	scene->processNormalKeyDown(key, OpenGL::GetModifiers(), Point(x, y));
}

void 	Framework::processNormalKeyUp	(unsigned char key, int x, int y)
{
	scene->processNormalKeyUp(key, OpenGL::GetModifiers(), Point(x, y));
}

void Framework::processSpecialKeyDown(int key, int x, int y) 
{
	scene->processSpecialKeyDown(key, OpenGL::GetModifiers(), Point(x, y));
}

void Framework::processSpecialKeyUp(int key, int x, int y) 
{
	scene->processSpecialKeyUp(key, OpenGL::GetModifiers(), Point(x, y));
}


void Framework::changeSize(int w, int h) 
{
	x = w; y = h;
}



void Framework::advanceScene()
{
	static double prevtime = getTime();

	double curtime = getTime();
	scene->advance(curtime, curtime-prevtime);
	prevtime = curtime;

//  Twee alternatieven	
	renderScene();
//	OpenGL::PostRedisplay();	
}

void Framework::initFramework( int argc, char **argv, const char * title)
{
	// give glut hints for window size/position
	OpenGL::InitWindowPosition(100,100);
	OpenGL::InitWindowSize(x,y);
	// user can override them with appropriate switches	
	OpenGL::Init(&argc, argv);

	// set default window type for creation 
	OpenGL::InitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);

    OpenGL::CreateWindow(title);
	OpenGL::DisplayFunc(fakeRenderFunc);

	OpenGL::IgnoreKeyRepeat(true);
	OpenGL::KeyboardFunc	(processNormalKeyDown);
	OpenGL::KeyboardUpFunc	(processNormalKeyUp);
	OpenGL::SpecialFunc		(processSpecialKeyDown);
	OpenGL::SpecialUpFunc	(processSpecialKeyUp);

	OpenGL::IdleFunc(advanceScene);

	OpenGL::ReshapeFunc(changeSize);
}

int Framework::startFramework(Scene & s) 
{
	scene = &s;
	OpenGL::MainLoop();
	
	return EXIT_SUCCESS; // never reached, GLUT MainLoop never returns
}


