#ifndef _FRAMEWORK_H
#define _FRAMEWORK_H


class Scene;

class Framework
{
private:
	static	int 	x;
	static	int 	y;
	static	double 	startTime;
	static	Scene * scene;
	
public:
	static 	void 	initFramework 	(int argc, char **argv, const char * title);
	static 	int 	startFramework	(Scene & s);

private:
	static	void 	processNormalKeyDown	(unsigned char key, int x, int y);
	static	void 	processNormalKeyUp		(unsigned char key, int x, int y);
	static	void 	processSpecialKeyDown	(int key, 			int x, int y);
	static	void 	processSpecialKeyUp		(int key, 			int x, int y);
	
	static	void 	fakeRenderFunc();
	static	void 	renderScene();
	static 	void 	changeSize(int w, int h);
	static	void 	advanceScene();
};

#endif //_FRAMEWORK_H
