

#ifndef FRUSTUM_H
#define FRUSTUM_H


/**
  *@author Wouter Koolen-Wijkstra
  */

#include <GL/gl.h>
class Box;
class Sphere;
#include "OpenGL.h"

enum TopoRel
{
	OUTSIDE,
	INTERSECT,
	INSIDE
};

/* For fairly interesting documentation about Frustum culling see
    http://www.flipcode.com/articles/article_frustumculling.shtml
*/

class OpenGL;

class Frustum
{
public: 
			Frustum(const Matrix<GLfloat> & MV = 	OpenGL::GetModelViewMatrix(),
					const Matrix<GLfloat> & P = 	OpenGL::GetProjectionMatrix());
	virtual ~Frustum();

	TopoRel getTopoRel(const Sphere & s) const;
	TopoRel getTopoRel(const Box 	& b) const;

	void draw() const;
	void drawTopoRel(const Sphere & s) const;
	const Matrix<GLfloat> & getM() const;

private:
    Matrix<GLfloat> 	P, MV, M;

	Vector<GLfloat>  	planes[3][2];
//		left, 	right,
//		bottom,	top,
//		near,	far;
	
	
};

#endif
