

#include "GLDisplayList.h"
#include "GLModelPart.h"

GLDisplayList::GLDisplayList()
	: valid(false)
{
	dl = OpenGL::GenLists(1);
}

GLDisplayList::~GLDisplayList()
{
	OpenGL::DeleteLists(dl, 1);
}

void GLDisplayList::draw(const GLModelPart & mp)
{
	if (valid)
	{
		OpenGL::CallList(dl);
	}
	else
	{
		OpenGL::NewList(dl, GL_COMPILE_AND_EXECUTE);
		mp.fillDL();
		OpenGL::EndList();
		valid = true;
	}
}

void GLDisplayList::invalidate()
{
	valid = false;
}
