#include "GLObject.h"
#include "utils.h"
#include "LinAlg.h"


GLObject::GLObject(unsigned int nvertices)
	: 	nvertices(nvertices),
		vertexbuffer(new GLfloat[3 * nvertices]),
		normalbuffer(new GLfloat[3 * nvertices])
{
}

GLObject::~GLObject()
{
		delete [] vertexbuffer;
		delete [] normalbuffer;
}

void GLObject::drawVertexNormals(double length, unsigned int from, unsigned int to) const
{
	if(to == (unsigned int)-1) to = nvertices;
	
	OpenGL::Disable(GL_LIGHTING);

	OpenGL::Color(1, 0, 1);
	OpenGL::Begin(GL_LINES);

	// for every vertex
	for (unsigned int i = from; i < to; i++)
	{
		Vector<GLfloat> v(3, &vertexbuffer[3*i]);
		Vector<GLfloat> n(3, &normalbuffer[3*i]);
		OpenGL::Vertex(v);
		OpenGL::Vertex(v + n * length);
	}
	OpenGL::End();
	OpenGL::Enable(GL_LIGHTING);
}
