#ifndef _LAMP_H
#define _LAMP_H


#include <GL/gl.h>
#include "LinAlg.h"

class Lamp
{
protected:

	Vector<GLfloat> 	ambient;
	Vector<GLfloat> 	diffuse;
	Vector<GLfloat> 	specular;
	Vector<GLfloat> 	pos;

	GLfloat				constant_attenuation;
	GLfloat				linear_attenuation;
	GLfloat				quadratic_attenuation;

	GLfloat				spot_exponent;
	Vector<GLfloat>		spot_direction;
	GLfloat				spot_cutoff;
	 

public:

	// Constructor for DIRECTIONAL LIGHT
	Lamp(
	const Vector<GLfloat> 	& 	ambient,
	const Vector<GLfloat> 	& 	diffuse,
	const Vector<GLfloat> 	& 	specular,
	const Vector<GLfloat> 	& 	dir);


	// Constructor for POSITIONAL LIGHT
	Lamp(
	const Vector<GLfloat> 	& 	ambient,
	const Vector<GLfloat> 	& 	diffuse,
	const Vector<GLfloat> 	& 	specular,
	const Vector<GLfloat> 	& 	pos,
	GLfloat						constant_attenuation,
	GLfloat						linear_attenuation,
	GLfloat						quadratic_attenuation,
	GLfloat						spot_exponent,
	const Vector<GLfloat>	&	spot_direction,
	GLfloat						spot_cutoff);


	virtual ~Lamp();

	void set(bool lit) 	const;
	void draw() 		const;

private:
	void 		setup() const;
	int			lampID;
};


#endif //_LAMP_H
