#include "GL/LightBuffer.h"
#include <cassert>
#include <cstdlib>
using namespace std;

LightBuffer::LightBuffer()
	: nlights(0), used(0), lightUsed(NULL)
{
}

LightBuffer::~LightBuffer()
{
	assert (lightUsed != NULL);
	delete [] lightUsed;
}

unsigned int 	LightBuffer::newLight()
{
	assert(nlights > 0);
	
	for (unsigned int i = 0; i < nlights; i++)
	{
			if (!lightUsed[i])
			{
				lightUsed[i] = true;
				used++;
				return i;
			}
	}
	assert(false /* No free light */);
	abort();
}

void 	LightBuffer::freeLight(unsigned int id)
{
	assert(id < nlights);
	assert(lightUsed[id] /* Light was not used?? */);
	lightUsed[id] = false;
	used--;
}

void LightBuffer::resize(unsigned int newlights)
{
	assert(nlights 		== 	0);
	assert(used 		== 	0);
	assert(lightUsed 	== 	NULL);	
	assert(newlights 	> 	0);

	delete [] 	lightUsed;
	nlights = 	newlights;
	lightUsed = new bool[nlights];

	for (unsigned int i = 0; i < nlights; i++)
	{
		lightUsed[i] = false;
	}
}


unsigned int LightBuffer::available() const
{
		assert(used <= nlights);
		return nlights-used;
}
