#include "Material.h"
#include "OpenGL.h"
#include "utils.h"


Material::Material(
const Vector<GLfloat> 	& ambient,
const Vector<GLfloat> 	& diffuse,
const Vector<GLfloat> 	& specular,
const Vector<GLfloat> 	& emission,
GLfloat					  shininess)
:
ambient		(ambient),
diffuse		(diffuse),
specular	(specular),
emission	(emission),
shininess	(shininess)
{
	assert(*ambient == 4);
	assert(*diffuse == 4);
	assert(*specular == 4);
	assert(*emission == 4);
}

void Material::set()
{
	OpenGL::Materialfv(GL_FRONT, GL_AMBIENT, 	ambient);
	OpenGL::Materialfv(GL_FRONT, GL_DIFFUSE, 	diffuse);
	OpenGL::Materialfv(GL_FRONT, GL_SPECULAR, 	specular);
	OpenGL::Materialfv(GL_FRONT, GL_EMISSION, 	emission);
	OpenGL::Materialf(GL_FRONT, GL_SHININESS, 	shininess);
}


