#include "Point.h"
#include "utils.h"
#include <cmath>

Point::Point() : x(0), y(0)
{
}

Point::Point(GLdouble x, GLdouble y) : x(x), y(y)
{
}

double Point::distance(const Point & p) const
{
	return sqrt(sqr(x - p.x) + sqr(y - p.y));	
}

Point Point::operator - (const Point & p) const
{
	return Point(x-p.x, y-p.y);
}

Point Point::operator + (const Point & p) const
{
	return Point(x+p.x, y+p.y);
}
	


ostream & operator << (ostream & s, const Point & p)
{
	return s << "(" << p.x << ", " << p.y << ")";
}
