#ifndef SP_H
#define SP_H


/**
  *@author Wouter Koolen-Wijkstra
  */

class Box;
class Sphere;
class Frustum;

#include <vector>
using namespace std;

class SPNode;

class SP
{
protected:
	Box 	* 	bound;
	Sphere  *	boundSphere;
	SP		* 	parent;

public:
			SP();
	virtual ~SP();

	// important for nodes
	virtual void 	draw() = 0;
	virtual Box * 	recalcBound() = 0;

	// taken care of by derived clases
	virtual void 	check(const Frustum & f, bool drawBound = false) = 0;
	virtual void 	invalidate();
	Box *			getBound();

	friend class SPNode;
};

class SPNode : public SP
{
	vector<SP*>	children;

public:
			SPNode();
	virtual ~SPNode();

	virtual void 	draw();
	virtual void 	check(const Frustum & f, bool drawBound = false);
	virtual Box * 	recalcBound();
	void			addChild(SP * child);
};

class SPLeaf : public SP
{
public:
			SPLeaf();
	virtual ~SPLeaf();
	
	virtual void 	draw() = 0;
	virtual Box * 	recalcBound() = 0;
	virtual void 	check(const Frustum & f, bool drawBound = false);
};


#endif
