#include "Scene.h"
#include "utils.h"
#include "Point.h"

#include <iostream>
#include <iomanip>
using namespace std;



Scene::Scene() : frames(0), waited(0)
{
}

Scene::~Scene()
{
}



void Scene::draw(int w, int h) const
{
	const_cast<int&>(frames)++;
}

void Scene::advance(double totaltime, double dt)
{
	waited += dt;
	if (waited > 1.0)
	{
		cout << "FPS: " << setprecision(2) << setw(8) << fixed << (frames/waited) << endl;
		waited = 0;
		frames = 0;
	}
}


void Scene::processNormalKeyDown	(unsigned char key, int modifiers, const Point & mouse)
{
	cout << "Normal key down: " << key  << "/" << modifiers << "@" << mouse << endl;
}

void Scene::processNormalKeyUp	(unsigned char key, int modifiers, const Point & mouse)
{
	cout << "Normal key up: " << key  << "/" << modifiers << "@" << mouse << endl;
}

void Scene::processSpecialKeyDown(int key, int modifiers, const Point & mouse)
{
	cout << "Special key down: " << key  << "/" << modifiers << "@" << mouse << endl;
}

void Scene::processSpecialKeyUp(int key, int modifiers, const Point & mouse)
{
	cout << "Special key up: " <<  key  << "/" << modifiers << "@" << mouse << endl;
}


