#ifndef _GRID_H
#define _GRID_H



#include "GL/OpenGL.h"

#include "GridModel.h"
#include "WorldObject.h"

class GLDisplayList;

class Grid : public WorldObject
{
public:
			Grid(int logsize);
	virtual ~Grid();

	double getH(const Vector<GLfloat> & xz) const;
	void draw(const Frustum & f) const;
	
	void setDrawBounds(bool value);	

protected:
	virtual void interactWithObject			(WorldObject 	& other);
	virtual	void interactWithPhysicalObject	(PhysicalObject & other);
	virtual void interactWithExplosion		(Explosion		& other);
	virtual void advance(double time, double dt);
	

	
private:
	GridModel 		model;
	GLDisplayList *	dl;
	bool			drawBounds;
};


#endif //_GRID_H
