#ifndef _TANK_H
#define _TANK_H
#include "GL/OpenGL.h"

#include "PhysicalObject.h"
#include "TankModel.h"

class Bullet;
class Explosion;

class Tank : public PhysicalObject //, public GLObject
{
public:
			Tank();
	virtual ~Tank();
	
	virtual void drawPO(const Frustum & f) const;
	virtual void advance(double time, double dt);

protected:
	virtual void 	onHitGround(double distance);
	virtual void 	interactWithExplosion		(Explosion		& other);
	virtual bool	recollect(vector<WorldObject*> & v);

private:
	double		a_cabine;
	double		a_funnel;
	
	double		av_cabine; // angular velocity
	double		av_funnel; // angular velocity

	double		drive; 		// drive speed
	double		turn; 		// turn speed

	double		firing;
	double		firedelay;
	
	TankModel	model;

	friend class TankCombat;
};


#endif // _TANK_H
