#include "GL/OpenGL.h"
#include "GL/Scene.h"
#include "GL/HomLinAlg.h"
#include "GL/Point.h"


class Lamp;
class Frustum;
class Grid;
class Axes;
class Water;
class Tank;
class WorldObject;

#include <vector>
using namespace std;



class TankCombat : public Scene
{
protected:

	HomMatrix<GLfloat>	world2view[2][2];
	HomMatrix<GLfloat>	model2world;

	Tank *				tank;
	Grid *				grid;
	Water *				water;
	Axes *				axes;
	Point				previousMouse;	

	void mouseButtonDown(float x, float y);
	void mouseButtonUp(float x, float y);
	void mouseDrag(float x, float y);

	virtual void processNormalKeyDown	(unsigned char key, int modifiers, const Point & mouse);
	virtual void processNormalKeyUp		(unsigned char key, int modifiers, const Point & mouse);
	virtual void processSpecialKeyDown	(int key, 			int modifiers, const Point & mouse);
	virtual void processSpecialKeyUp	(int key, 			int modifiers, const Point & mouse);
	
	void drawScene(const Matrix<GLfloat> & world2view, const Frustum & f, bool isTank) const;
	
public:
			TankCombat(unsigned int 		gridsize);
	virtual ~TankCombat();

	void 	draw(int w, int h) const;
	void 	advance(double totaltime, double dt);

private:
	unsigned int 	vx0, vy0, vx1, vy1;

	vector<WorldObject*> 	objects;
	vector<Lamp*> 			lamps;
	
	const unsigned int 		gridsize;
	const unsigned int 		fieldsize;
	const double		 	d;
};
