#include "Water.h"

#include <cstdlib>
#include "utils.h"
#include "array.h"
#include "GL/Material.h"
#include "GL/HomLinAlg.h"


Water::Water(double size, unsigned int n, unsigned int frames)
	: model(size, n, frames)
{
}


Water::~Water()
{
}

void Water::drawVertexNormals(double length) const
{
	model.drawVertexNormals(length, currentFrame);
}


void Water::draw(const Frustum & f) const
{
}

void	Water::drawTransparent(const Frustum & f) const
{
	model.draw(currentFrame, waterlevel);
}

void Water::advance(double time, double dt)
{
	currentFrame =  ((unsigned int)(0.5*time*model.frames)) % model.frames;
	waterlevel = 	cos(time/4)*8-4;
}

void Water::interactWithObject	(WorldObject 	& other)
{
	other.interactWithWater(*this);
}
