#ifndef _WATER_H
#define _WATER_H

#include "GL/OpenGL.h"
#include "GL/LinAlg.h"
#include "WaterModel.h"
#include "WorldObject.h"


class Water : public WorldObject
{
public:
			Water(double size, unsigned int n, unsigned int frames);
	virtual ~Water();
	
	virtual	void 	draw(const Frustum & f) const;
	virtual void	drawTransparent(const Frustum & f) const;
	void drawVertexNormals(double length) const;
	

protected:
	virtual void interactWithObject	(WorldObject 	& other);
	virtual void advance(double time, double dt);

	

private:
	double						waterlevel;
	unsigned int				currentFrame;
	WaterModel 					model;
};


#endif //_WATER_H
