#ifndef _WATERMODEL_H
#define _WATERMODEL_H

#include "GL/OpenGL.h"
#include "GL/LinAlg.h"
#include "GL/Material.h"


class WaterModel
{
public:
			WaterModel(double size, unsigned int n, unsigned int frames);
	virtual ~WaterModel();
	
	void draw(int currentFrame, double waterlevel) const;
	void drawVertexNormals(double length, int currentFrame) const;
	
protected:
	void 	bufferize();

private:
	double 						size;
	unsigned int 				n;
	unsigned int				frames;
	GLfloat *					vertexbuffer;
	GLfloat **					normalbuffer;
	GLuint **					indexbuffer;

	static Material WaterMaterial;

	friend class Water;
};


#endif //_WATERMODEL_H
