
#ifndef WORLDOBJECT_H
#define WORLDOBJECT_H


/**
  *@author Wouter Koolen-Wijkstra
  */


#include <vector>
using namespace std;  

class Grid;
class Water;
class PhysicalObject;
class Explosion;
class Frustum;

class WorldObject
{
public: 
			WorldObject();
	virtual ~WorldObject();

	virtual void interactWithObject		(WorldObject 	& other) = 0;
	virtual void interactWithGrid		(Grid 			& other);
	virtual void interactWithWater		(Water 			& other);
	virtual void interactWithExplosion	(Explosion		& other);
	virtual	void interactWithPhysicalObject(PhysicalObject & other);


	virtual void	advance(double time, double dt) = 0;
	virtual bool	recollect(vector<WorldObject*> & v);

	virtual void	setLights(bool lit) 				const;
	virtual void	draw(const Frustum & f)				const;
	virtual void	drawTransparent(const Frustum & f) 	const;	
};

#endif
